

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.RenderedImage;
import javax.swing.JPanel;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.Image;
import java.awt.TexturePaint;
import java.awt.Polygon;
import java.util.Hashtable;
import java.awt.image.BufferedImage;
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.renderable.ParameterBlock;
import java.awt.event.KeyEvent;
import javax.swing.JTree;
import javax.swing.tree.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;


public class DisplayJAI extends JPanel implements MouseListener,MouseMotionListener,MouseWheelListener{
    /** image to display */
    protected BufferedImage source = null;
   
    int sourcecx,sourcecy;
    int sourcew,sourceh;
    
    
    BufferedImage target = null;
    /** image origin relative to panel origin */
    protected int originX = 0;
    protected int originY = 0;
    
    int secx=0;
    int secy=0;
    Color seccolor1 = Color.red;
    Color seccolor2 = Color.blue;
    boolean mouse=false;
    
    private final Cursor defCursor = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);
    private final Cursor hndCursor = Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
    private final Point pp = new Point();
    Color TraColor = new Color(0.0f,0.0f,0.0f,0.0f);
    //Interpolation interp = Interpolation.getInstance(Interpolation.INTERP_BICUBIC_2);
    float alpha=0.5f;
    int radius=10;

    boolean particles=true;
    boolean mousein=false;
    Point mouseLocation = new Point(0,0);
    JScrollPane preScroll=null;
    
    JScrollBar radiusSB=null;
    
    
    //Point mouseLocation = new Point(0,0);

    int mouseState=1;
    /* 
       0: move/zoom image
       1: add particle
       2: remove particle
       3: move/pick particle
       
    */
    
    int tid;
    double px,py,pz;
    


    Color cfillcolor= new Color(1.0f,0.0f,1.0f);

    double classR=1.0;
    double cRadius=5.0;
    
    
    
    RenderedImage rop =null;
    BufferedImage dbuffer=null;
    BufferedImage dbuffer2=null;
    
    
    public void setPaintingColor(Color dcolor){
	int R=dcolor.getRed();float fR = ((float)(R))/255.0f;
	int G=dcolor.getGreen();float fG = ((float)(G))/255.0f;
	int B=dcolor.getBlue();float fB = ((float)(B))/255.0f;
	cfillcolor= new Color(fR,fG,fB);
	
    }
    public void setRadius(int rad){
	radius = rad;
	
	makeImage();repaint();
    
    }
   
    public void setTransparent(float dalpha){
	alpha = dalpha;
	if(alpha>1.0f)alpha=1.0f;if(alpha<0.0f)alpha=0.0f;
	//System.out.println(+alpha);
	makeImage();repaint();
    
    }
    public void setJScrollPane(JScrollPane dpreScroll){
	preScroll = dpreScroll;
	    
    }
    
    

    public void setImage(BufferedImage image){
	source = image;
	repaint();
    }

    /** constructor with given image */
    public DisplayJAI(BufferedImage image) {
        super();
        setLayout(null);
        source = image;
	target = new BufferedImage(source.getWidth(),source.getHeight(),BufferedImage.TYPE_INT_ARGB);
        // Swing geometry
        int w = source.getWidth();sourcew=w;
        int h = source.getHeight();sourceh=h;
	sourcecx=w/2;
	sourcecy=h/2;
        Insets insets = getInsets();
        Dimension dim = new Dimension(w + insets.left + insets.right,
                                      h + insets.top + insets.bottom);
	tid=0;
	px=1.0;
	py=1.0;
	pz=1.0; 
	mouseState=1;
        setPreferredSize(dim);
	addMouseWheelListener(this);
	
    

	addMouseMotionListener(this);
        addMouseListener(this);
	makeImage();
    }
       

    /** move image within it's container */
    public void setOrigin(int x, int y) {
        originX = x;
        originY = y;
        makeImage();repaint();
    }
    
    /** get the image origin */
    public Point getOrigin() {
        return new Point(originX, originY);
    }
    
    
    public void set(BufferedImage im) {
        source = im;
	
        setSize();
        revalidate();
        makeImage();repaint();
    }
    
    /** use to display a new image, with origins */
    public void set(BufferedImage im, int x, int y) {
        source = im;
	
        setSize();

        originX = x;
        originY = y;

        revalidate();
        makeImage();repaint();
    }
    
    
    /** paint routine */
    public synchronized void paintComponent(Graphics g){

        Graphics2D g2d = (Graphics2D)g;
	
        if(source == null){
            g2d.setColor(getBackground());
            g2d.fillRect(0, 0, getWidth(), getHeight());
            return;
        }
	
        // account for borders
        Insets insets = getInsets();
        int tx = insets.left + originX;
        int ty = insets.top  + originY;
	
	
        // clear damaged component area
        Rectangle clipBounds = g2d.getClipBounds();
        g2d.setColor(getBackground());
        g2d.fillRect(clipBounds.x,
                     clipBounds.y,
                     clipBounds.width,
                     clipBounds.height);
	
	
	g2d.drawRenderedImage(dbuffer,AffineTransform.getTranslateInstance(0,0));
	
	if(target!=null)
	    g2d.drawRenderedImage(dbuffer2,AffineTransform.getTranslateInstance(0,0));
	
	if(mousein){
	   
	    
	    int dx = mouseLocation.x;
	    int dy = mouseLocation.y;
	    g2d.setColor(cfillcolor);
	    
	    g2d.fillOval(dx-radius,dy-radius,2*radius,2*radius);
	    
	    
	}
	
	
	
    }
    
    
   
    
    public void makeImage(){
	
	dbuffer = new BufferedImage(source.getWidth(),source.getHeight(),BufferedImage.TYPE_INT_ARGB);
	
	
	AffineTransform at =
	    AffineTransform.getScaleInstance(1.0f,1.0f);
	
        Graphics2D g2d = (Graphics2D)dbuffer.getGraphics();
	

	if(target!=null){
	    dbuffer2 = new BufferedImage(target.getWidth(),target.getHeight(),BufferedImage.TYPE_INT_ARGB);
	    Graphics2D g2dt = (Graphics2D)dbuffer2.getGraphics();
	    g2dt.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,alpha));
	    g2dt.drawRenderedImage(target,at);
	    g2dt.dispose();
	}
	
	g2d.drawRenderedImage(source,at);
	
	g2d.dispose();
	
    }
    
    
   
 public void setSaveMasks(String filename){
     	
     try{
	    
	    FileOutputStream output = 
		new FileOutputStream(filename);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println("P3");
	    int tsy = target.getHeight();
	    int tsx = target.getWidth();
	    pwp.println(tsx+" "+tsy);
	    pwp.println(255);
	    
	    
	    	    
	    int i,j;
	    
	    
	    for(i=0;i<tsy;i++){
		
		
		for(j=0;j<tsx;j++){
		    int dR,dG,dB,dA;
		    int RGB = target.getRGB(j,i);
		    dA = (RGB >> 24) & 255;
		    dR = (RGB >> 16) & 255;
		    dG = (RGB >> 8) & 255;
		    dB = (RGB >> 0) & 255;
		    
		    pwp.print(dR+" "+dG+" "+dB+" ");
		    
		}
		pwp.println("");
	    }
	    
	    pwp.close();
	    output.close();
	}catch (IOException e){
	    System.out.println("IOException");
	    
	}
 
 
 }

    
    
    public void initScale() {
            
            makeImage();
	    repaint();
	    
	    
	    setSize();
        }
    private void setSize(){
	double w = source.getWidth();
	double h = source.getHeight();
	int iw = ((int)(w));if(w-iw>=0.5)iw++;
	int ih = ((int)(h));if(h-ih>=0.5)ih++;
	
	
	Insets insets = getInsets();
	Dimension dim = new Dimension(iw + insets.left + insets.right,
				      ih + insets.top + insets.bottom);
	
	
	setPreferredSize(dim);
	getParent().doLayout(); 
    }
    private void setSize(Point mp){
	double w = source.getWidth();
	double h = source.getHeight();
	int iw = ((int)(w));if(w-iw>=0.5)iw++;
	int ih = ((int)(h));if(h-ih>=0.5)ih++;
	
	
	Insets insets = getInsets();
	Dimension dim = new Dimension(iw + insets.left + insets.right,
				      ih + insets.top + insets.bottom);
	
	getParent().
	setPreferredSize(dim);
	getParent().doLayout(); 
    }
    
    public void mouseDragged(MouseEvent e) {mousein=false;
	if(target!=null){
	   
	    Graphics2D g2dt = (Graphics2D)target.getGraphics();
	    int dx =  e.getPoint().x;
	    int dy =e.getPoint().y;
	    g2dt.setColor(cfillcolor);
	    g2dt.fillOval(dx-radius,dy-radius,2*radius,2*radius);
	    
	    //Graphics2D g2dt2 = (Graphics2D)dbuffer2.getGraphics();
	    //g2dt2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,alpha));
	    //g2dt2.drawRenderedImage(target,AffineTransform.getScaleInstance(1.0f,1.0f));
	    g2dt.dispose();
	    //g2dt2.dispose();
	    makeImage();
	    repaint();
	}
	
    } 
	public void mouseMoved(MouseEvent e){mousein=true;
	
	    mouseLocation.setLocation(e.getPoint());
	    
	    repaint();
	    
	
    }
    
   
   
    public void mousePressed(MouseEvent e) {mousein=true;mouseLocation.setLocation(e.getPoint());
	makeImage();
	repaint();
	
    }
        
    public void mouseExited(MouseEvent e) {mousein=false;}
    public void mouseEntered(MouseEvent e){mousein=true;mouseLocation.setLocation(e.getPoint());}
    public void mouseReleased(MouseEvent e) {mousein=true;mouseLocation.setLocation(e.getPoint());
	preScroll.setCursor(defCursor);
	makeImage();
	repaint();
    }
    public void initRadius(){
	cRadius = 5.0;
	makeImage();
	repaint();	
    
    }
    public void mouseClicked(MouseEvent e){mousein=true;
	if (e.getClickCount() >= 2){//double click for scale reset
	    
	}

    }
    
    public void mouseWheelMoved(MouseWheelEvent e) { 
	/*
	   0: Z(Time)
	   1: Class
	   2: Radius
	   3: Zoom
	*/
	  
	int val = e.getWheelRotation();
	
	//mycontrol.setMouseWheelState(mouseWheelState);
	/*
	if(mouseState==1||mouseState==3){
	    if(keyaction.mouseWheelState==0){
		if(myIWpcontrol!=null)myIWpcontrol.IncMW(val);
	    }else if(keyaction.mouseWheelState==1){
		if(mypcontrol!=null)mypcontrol.changeSelectedClass(val);
	    }else if(keyaction.mouseWheelState==2){
		cRadius += 0.5*((double)(val));if(cRadius<=0.0)cRadius=0.0;
		mypcontrol.setpRadius();
		repaint();
	    }
	}else{
	    
	    changeScale(e.getWheelRotation(),e.getPoint());//updatePreferredSize(e.getWheelRotation(), e.getPoint());
	    repaint();
	}
	*/
	//if(!(mouseState==1||mouseState==3)){
	//changeScale(e.getWheelRotation(),e.getPoint());//updatePreferredSize(e.getWheelRotation(), e.getPoint());
	radius += val;if(radius<1)radius=1;if(radius>255)radius=256;
	radiusSB.setValue(radius);
	repaint();
	    //}
	
    }
    

}
