class PoissonIE{
 public:
  int sx,sy;
 
  int MAXITE;
  double EPS;
  PoissonIE(int dx,int dy){
    sx = dx;
    sy = dy;
    MAXITE=10000;
    
    EPS=0.00001;
   
    
    
  }
  ~PoissonIE(){
   
    
  }
  void setBoundary(Image *in,Image *out){
    int i,j;
    int ii,jj;
     for(i=0;i<sy;i++)
       for(j=0;j<sx;j++)out->img[i][j]=in->img[i][j];
    
    for(i=1;i<sy-1;i++){
      for(j=1;j<sx-1;j++){
	if(in->img[i][j]==255.0){
	  if(in->img[i][j+1]!=255.0||in->img[i][j-1]!=255.0||in->img[i+1][j]!=255.0||in->img[i-1][j]!=255.0){
	    out->img[i][j]=128.0;
	  }
	}

      }
    
    }

  }
  
  
  void solve(Image *inS,Image *inT,Image *mask,Image *out,double Alpha,double Beta){
    int loop;
    
    int i,j;
   
    for(i=0;i<sy;i++)
      for(j=0;j<sx;j++){
	if(mask->img[i][j]==255.0){
	  out->img[i][j]=inS->img[i][j];
	}else{
	  out->img[i][j]=inT->img[i][j];
	}
      }
    Image *tmp1 = new Image(inS->sx,inS->sy);
    Image *tmp2 = new Image(inS->sx,inS->sy);
    
    for(j=0;j<sx;j++)
      for(i=0;i<sy;i++){
	
	if(mask->img[i][j]==255.0){
	 double sum_vq=0.0;
	 double num=0.0;
	  if(i>0){num++;
	    if(fabs(-inS->img[i-1][j]+inS->img[i][j])<Alpha*fabs(-inT->img[i-1][j]+inT->img[i][j])){
	      sum_vq+=Beta*(-inT->img[i-1][j]+inT->img[i][j])+(1.0-Beta)*(-inS->img[i-1][j]+inS->img[i][j]);
	    }else{
	      sum_vq+=(-inS->img[i-1][j]+inS->img[i][j]);
	    }
	  }
	  if(j>0){num++;
	    if(Alpha*fabs(-inT->img[i][j-1]+inT->img[i][j])>fabs(-inS->img[i][j-1]+inS->img[i][j])){
	      sum_vq+=Beta*(-inT->img[i][j-1]+inT->img[i][j])+(1.0-Beta)*(-inS->img[i][j-1]+inS->img[i][j]);
	    }else{
	      sum_vq+=(-inS->img[i][j-1]+inS->img[i][j]);
	    }
	  }
	  if(i<sy-1){num++;
	    if(Alpha*fabs(-inT->img[i+1][j]+inT->img[i][j])>fabs(-inS->img[i+1][j]+inS->img[i][j])){
	      sum_vq+=Beta*(-inT->img[i+1][j]+inT->img[i][j])+(1.0-Beta)*(-inS->img[i+1][j]+inS->img[i][j]);
	    }else{
	      sum_vq+=(-inS->img[i+1][j]+inS->img[i][j]);
	    }
	  }
	  if(j<sx-1){num++;
	    if(Alpha*fabs(-inT->img[i][j+1]+inT->img[i][j])>fabs(-inS->img[i][j+1]+inS->img[i][j])){
	      sum_vq+=Beta*(-inT->img[i][j+1]+inT->img[i][j])+(1.0-Beta)*(-inS->img[i][j+1]+inS->img[i][j]);
	    }else{
	    sum_vq+=(-inS->img[i][j+1]+inS->img[i][j]);
	    }
	  }
	  
	  
	  if(num<=0.0)num=1.0;
	  tmp2->img[i][j]= (1.0/num);
	  tmp1->img[i][j]= sum_vq;
	 
	}
      }
    for(loop=0;loop<MAXITE;loop++){
       double error = 0.0;
       double absv = 0.0;
      for(j=0;j<sx;j++){
	for(i=0;i<sy;i++){
	  double sum_n=0.0;
	  
	  if(mask->img[i][j]==255.0){
	   
	    if(i>0){
	      sum_n+=out->img[i-1][j];
	    }
	    if(j>0){
	      sum_n+=out->img[i][j-1];
	    }
	    if(i<sy-1){
	      sum_n+=out->img[i+1][j];
	    }
	    if(j<sx-1){
	      sum_n+=out->img[i][j+1];
	    }
	    
	    double newval = tmp2->img[i][j]*(sum_n+tmp1->img[i][j]);
	    error+=fabs(newval-out->img[i][j]);
	    absv+=fabs(newval);
	    out->img[i][j]=newval;
	  }
	}
      }
      
      
      if(error/absv < EPS)break;
      
    }
    delete tmp1;
    delete tmp2;
  }


 
};

